.nolist
#include <avr/io.h>
#include "param.h"

.list

.section .bss

XStart:		.ds.b	1
YCnt:		.ds.b	1

#define	R_RAS	r3
#define	R_CAS	r4
#define	R_RAS_W	r5
#define	R_CAS_W r6

.section .text
//.global SIG_OUTPUT_COMPARE2A
//SIG_OUTPUT_COMPARE2A:
.global SIG_OUTPUT_COMPARE0
SIG_OUTPUT_COMPARE0:

	push	r16
	in r16, _SFR_IO_ADDR(SREG)
	sbi LCD_com0port, LCD_LP
	push	r16
	push	r19
	push	r20
	cbi LCD_com0port, LCD_LP

	ldi		r19,	C_CP
	
	cbi		LCD_com1port, LCD_FLM

	lds		r16,	YCnt							// Zeilenadresse laden
	out		LCD_dataport,	r16						// ROW Adresse auf Port ausgeben

#ifdef	LCD_M										// M/AC
	cbi		LCD_com1port, LCD_M
	sbrc	r16,0
	sbi		LCD_com1port, LCD_M
#endif

	out		LCD_com0port,	R_RAS					//RAS Signal

	lds		r16,	viewstart						// Spalten start Adresse laden
#ifdef GRAYSCALE
	lds		r20, GrayCnt
	sbrc	r20,1									// Bei 3,2 Frame 1 bei 1 frame 0
	subi	r16, -128
#endif

	ldi		r20,	XSIZE/4/4						// Spaltencounter
Xshift:						
	out		LCD_com0port,	R_RAS			//RAS Signal
	out		LCD_dataport,	r16				//Column Adresse auf Port ausgeben
	out		LCD_com0port,	R_CAS			//CAS Signal
	inc		r16								//Column Adresse + 1
	out		LCD_com0port,	r19				//CP Signal (LCD)

	out		LCD_com0port,	R_RAS			//RAS Signal
	out		LCD_dataport,	r16				//Column Adresse auf Port ausgeben
	out		LCD_com0port,	R_CAS			//CAS Signal
	inc		r16								//Column Adresse + 1
	out		LCD_com0port,	r19				//CP Signal (LCD)

	out		LCD_com0port,	R_RAS			//RAS Signal
	out		LCD_dataport,	r16				//Column Adresse auf Port ausgeben
	out		LCD_com0port,	R_CAS			//CAS Signal
	inc		r16								//Column Adresse + 1
	out		LCD_com0port,	r19				//CP Signal (LCD)

	out		LCD_com0port,	R_RAS			//RAS Signal
	out		LCD_dataport,	r16				//Column Adresse auf Port ausgeben
	out		LCD_com0port,	R_CAS			//CAS Signal
	inc		r16								//Column Adresse + 1
	out		LCD_com0port,	r19				//CP Signal (LCD)

	dec		r20				
	brne	Xshift

	ldi		r16,	C_norm			
	out		LCD_com0port,	r16

	lds		r16,	YCnt							// Zeilenadresse laden
	tst		r16
	brne	not_secline
	sbi		LCD_com1port, LCD_FLM
not_secline:

	inc		r16
	cpi		r16,	YSIZE							// Zeilenzhler berechnen
	brlo	not_firstline							// Bildende ?

	wdr
	clr		r16
#ifdef GRAYSCALE
	lds		r20, GrayCnt
	dec		r20
	brne	next_frame
	ldi		r20,3
next_frame:										
	sts		GrayCnt, r20
#endif

#if ((defined(COMMAND_TIMEOUT))&&(COMMAND_TIMEOUT>0))
	lds r19, ctimeout
	dec r19
	sts ctimeout, r19
#endif
	
not_firstline:
	sts YCnt, r16

	pop	r20
	pop r19
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
reti

//ca 515 takte +10

// -------------------------
// SET Pixel

.global lcd_setpixel		// X: r25:r24  Sonstige register r21,r19,r18,r17
lcd_setpixel:				// Y: r22		
							// C: r20
	push	r17
	push	r18
	push	r19
	push	r21
//	push	r22
	push	r24
	push	r25

	mov r21, r24
	andi r21, 3
	ldi r19, 128
	cpi r21, 0
	breq exitshift
shift:						// r19 = 128>>r21
	lsr r19
	dec r21
	brne shift
exitshift:
	lsr r25
	ror r24
	lsr r25
	ror r24

	mov		r18, r19
	com		r18
//Frame 0
	cli

	out		LCD_dataport,	r22			//	ROW Adresse							
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	sbrs	r20, 6
	and		r21,	r18						//	Bit lschen
	sbrc	r20, 6
	or		r21,	r19						//	Bit setzen
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E
//frame1
#ifdef GRAYSCALE
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	subi	r24,	-128
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop	
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	sbrs	r20, 7
	and		r21,	r18						//	Bit lschen
	sbrc	r20, 7
	or		r21,	r19						//	Bit setzen
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E
#endif
	ldi		r19,	C_norm		 
	out	LCD_com0port,	r19
	sei
	
	pop	r25
	pop	r24
//	pop	r22
	pop	r21
	pop	r19
	pop	r18
	pop	r17
exitbit2:
ret
//ca 81 takte +36

//-----------------------
// write byteeg
.global lcd_writebyteg		// X: r24
lcd_writebyteg:				// Y: r22
#ifdef GRAYSCALE			// DATA: r20
	clr r21
	clr r23
	rol r20
	rol r21
	rol r20
	rol r23
	rol r20
	rol r21
	rol r20
	rol r23
	rol r20
	rol r21
	rol r20
	rol r23
	rol r20
	rol r21
	rol r20
	rol r23

	ldi	r20,	C_CAS_OE
	lsl	r24

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS
	
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r20			//	CAS+OE+Drv_E
	out		LCD_dataport,	r21			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS_W
						
	out		LCD_com0port,	R_RAS_W		//	RAS
	subi	r24,	-128			
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r20			//	CAS+OE	
	out		LCD_dataport,	r23			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS_W

	ldi		r20,	C_norm	
	out		LCD_com0port,	r20			//	normal zustand
	
	sei
#endif
	ret


//-----------------------
// write byteex

.global lcd_writebyteex		// X: r24		sonstige register r23, (r21)
lcd_writebyteex:			// Y: r22
							// DATA: r20
							//Textcol: r18
							//Backcol: r16

	push	r21
	push	r23
	push	r24
	//push	r20
	//push	r22
		
#ifdef GRAYSCALE
	mov		r23,r20
	clr		r21				//Textcol
	sbrc	r18,7
	mov		r21,r20
	sbrs	r18,6
	clr		r20
	
	com		r23				//BGcol
	sbrc	r16,7
	or		r21,r23
	sbrc	r16,6
	or		r20,r23

#endif
	
	ldi	r23,	C_CAS_OE
	lsl	r24

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	
	out		LCD_com0port,	R_RAS_W		//	RAS		
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r20
	inc		r24							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
#ifdef GRAYSCALE
	//dec		r24
	subi	r24,			-127		//  +128
	out		LCD_com0port,	R_RAS_W		//	RAS		
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r21			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r21
	inc		r24							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r21			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
#endif
	ldi		r20,	C_norm	
	out		LCD_com0port,	r20			//	normal zustand
	
	sei
	
	//pop	r22
	//pop	r20
	pop	r24
	pop	r23
	pop	r21
exitbyteex:
	ret										//ca 44 takte +32


//-----------------------
// write byte

.global lcd_writebyte		// X: r24		sonstige register r23
lcd_writebyte:				// Y: r22
							// DATA: r20
//	cpi r24, (XSIZEV/8)
//	brsh exitbyte
//	cpi r22, lo8(YSIZE)
//	brsh exitbyte
	push	r23
	push	r24
		
	ldi	r23,	C_CAS_OE
	lsl	r24

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r20
	inc		r24							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W

#ifdef GRAYSCALE	
	out		LCD_com0port,	R_RAS_W		//	RAS	
	subi	r24, -128
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r20
	dec		r24							//	COL adresse -1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
#endif
	ldi		r20,	C_norm	
	out		LCD_com0port,	r20			//	normal zustand
	
	sei
	
	pop	r24
	pop	r23
exitbyte:
	ret										//ca 44 takte +30

//------------------------
// write char

.global lcd_writechar		// X: r24		sonstige Register	R21,
lcd_writechar:				// Y: r22							
//	cpi r24, (XSIZEV/8)		// C: r20
//	brsh exitchar			// TC: r18				
//	cpi r22, lo8(YSIZE)		// BC: r16
//	brsh exitchar
	
	push	r17
	push	r19
	push	r21
	push	r22
	push	r23
	push	r24

	mov ZL, r20	
	ldi ZH, TEXT_Y
	mul ZL, ZH
	movw ZL, r0
	subi ZL, lo8(-(font))
	sbci ZH, hi8(-(font))
	ldi r21, TEXT_Y
	clr	r1

	lsl r24

#ifdef GRAYSCALE
	rol		r16
	ror		r18
	rol		r16
	ror		r18
#endif

	ldi r16,	C_CAS_OE
	ldi	r17,	C_norm

wchar:
	lpm r20, Z+				// Byte laden

#ifdef GRAYSCALE		
	mov		r23,r20
	clr		r19				//Textcol
	sbrc	r18,5
	mov		r19,r20
	sbrs	r18,4
	clr		r20
	
	com		r23				//BGcol
	sbrc	r18,6
	or		r19,r23
	sbrc	r18,7
	or		r20,r23
#endif
	
	cli
	out		LCD_dataport,	r22			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r16			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r20
	inc		r24							//	Col A.	+1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r16			//	CAS+OE	
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS+WE

#ifdef GRAYSCALE	
	out		LCD_com0port,	R_RAS_W		//	RAS
	subi	r24,	-127
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r16			//	CAS+OE
	out		LCD_dataport,	r19			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r19
	inc		r24							//	Col A.	+1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r16			//	CAS+OE	
	out		LCD_dataport,	r19			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS+WE
	subi	r24,	129
#else
	dec		r24							//	Col A.	-1
#endif

	out		LCD_com0port,	r17			//	normal zustand
	sei
	
	inc		r22							//	Row A.	+1
	dec		r21
	brne wchar
	
	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r19
	pop		r17

exitchar:
ret		// 437 takte (+413)

//------------------------
// Clear LCD

.global lcd_clear		// 		sonstige Register	R18,R19,R20,R21,r22
lcd_clear:				// 
	
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	
	ldi	r18,	C_norm
	ldi	r22,	C_CAS_WCLR
	
#ifdef GRAYSCALE
	ldi	r19,	XVSIZEGR/4/4
#else
	ldi	r19,	XVSIZESW/4/4
#endif

	clr	r20
	clr	r21

	wrow:
	cli
	out		LCD_dataport,	r20			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
				
	out		LCD_com0port,	r18			//	normal zustand
	sei

	inc		r21							//	COL adresse +1
	dec		r19
	brne	wrow

	#ifdef GRAYSCALE
	ldi	r19,	XVSIZEGR/4/4
#else
	ldi	r19,	XVSIZESW/4/4
#endif
	clr		r21
	inc		r20							//	Row A.	+1
	brne	wrow

#ifdef GRAYSCALE	
	
	ldi		r19,	XVSIZEGR/4/4
	clr		r20
	ldi		r21,	128

	wrowg:
	cli
	out		LCD_dataport,	r20			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS

	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE		
	out		LCD_com0port,	r18			//	normal zustand
	sei

	inc		r21							//	COL adresse +1
	dec		r19
	brne	wrowg

	ldi		r19,	XVSIZEGR/4/4
	ldi		r21,	128
	inc		r20							//	Row A.	+1
	brne	wrowg
#endif

	pop	r22
	pop	r21
	pop r20
	pop	r19
	pop r18
						//ca 217881 takte *2
ret
