#define F_CPU		16000000UL

#define Framerate	75

#define 	GRAYSCALE					// Graustufen einschalten

#define 	COMMAND_TIMEOUT	65			// Timeout in Frames
//#define		GRAYMOD					// Vermeidet Flackern der Graustufen 

#define XSIZE		320
#define YSIZE		240

#define XOScan		0
#define YOScan		0

#define TEXT_X		8
#define TEXT_Y		12
#define Zeilen		(YSIZE/TEXT_Y)
#define Spalten 	(XSIZE/TEXT_X)

#define DDRAM		512

#define YMin		(DDRAM/256)
#define YMax		YMin+YSIZE
#define YScan		YMin+YSIZE+YOScan
#define	RELOAD		(F_CPU/8/(Framerate*(YSIZE+YOScan)))-1
#define XVSIZEGR	320
#define XVSIZESW	320

// DATA Port
#define		LCD_dataport	_SFR_IO_ADDR(PORTA)
#define		LCD_datapin		_SFR_IO_ADDR(PINA)
#define		LCD_dataddr		_SFR_IO_ADDR(DDRA)

// COM0 Port
#define		LCD_com0port	_SFR_IO_ADDR(PORTC)
#define		LCD_com0pin		_SFR_IO_ADDR(PINC)
#define		LCD_com0ddr		_SFR_IO_ADDR(DDRC)

#define 	RAM_RAS		5
#define 	RAM_CAS		3
#define 	RAM_OE		7
#define 	RAM_WE		6
#define 	LCD_CP		0
#define 	LCD_LP		1
#define		Drv_E		2
#define		Drv_dir		4

// COM1 Port
#define		LCD_com1port	_SFR_IO_ADDR(PORTD)
#define		LCD_com1pin		_SFR_IO_ADDR(PIND)
#define		LCD_com1ddr		_SFR_IO_ADDR(DDRD)

#define 	LCD_FLM		6
//#define 	LCD_M		1
#define 	RTX			5
#define 	LCD_OnOff	7

// com0

#define		C_norm		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(1<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_RAS		((1<<RAM_WE)|(0<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CAS		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CP		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(1<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))

#define		C_RAS_W		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CAS_OE	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(0<<Drv_E)|(1<<Drv_dir))
#define		C_CAS_W		((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(0<<Drv_E)|(1<<Drv_dir))

#define		C_CAS_OECLR	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CAS_WCLR	((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
